searchNodes=[{"doc":"Fictitious is a tool that enables you to create a fictitious data in elixir. It helps you to create mock data for your unit test without having the hassle of preparing the data in an convoluted order according to their associations that they have. Fictitious will ensure that whatever ecto schema that is specified, you will get the schema created for you.InstallationFictitious only generates fictitious data hence it is recommended that you install them in test environment only but feel free to play around with Fictitious by having it installed in normal dev environment. Inside your mix.exs file add {:fictitious, &quot;~&gt; 0.2.0&quot;, only: :test} as one of your dependency:defp deps do [ ... {:fictitious, &quot;~&gt; 0.2.0&quot;, only: :test}, ... ] endOnce you have it installed, you need to configure the Fictitious repo by adding the following configuration to your test.exs file:config :fictitious, :repo, default: YourApp.RepoNotice we put it inside test.exs file. This is because Fictitious is created to help you create mock data for your unit test hence most of the time you will definitely put this configuration in test environment only.In case your application has more than one Repo it is possible to configure multiple repos. In fact, you could configure as many as you want. To do so you could add more repos into the fictitious :repo configs as follow:config :fictitious, :repo, default: YourApp.Repo, second_repo: YourApp.SecondRepo, third_repo: YourApp.ThirdRepoThe default repo will be used by default by Fictitious and it is mandatory to be specified.How to UseBasicsGiven you have the following ecto schema inside your app:defmodule YourApp.Schema.Person do use Ecto.Schema import Ecto.Changeset schema &quot;persons&quot; do field :name, :string field :age, :integer field :email, :string timestamps() end ... endTo generate fictitious data of a person you could simply call fictionize/1 function as follow:iex&gt; Fictitious.fictionize(YourApp.Schema.Person) {:ok, %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 35, name: &quot;2cBfxcqnB0B5iqhYvK83RamaDa8KM0PvPpT1kVao&quot;, age: 514, email: &quot;2cBfxcqnB0B5iqhYvK83RamaDa8KM0PvPpT1kVao&quot;, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }}fictionize/1 will simply generate fictitious value according to its field's type. The currently supported primitive types by Fictitious can be found in official ecto documentation.In case you want some fields to be specified manually, you could overwrite the values that are generated by Fictitious by providing the second argument:iex&gt; Fictitious.fictionize(YourApp.Schema.Person, name: &quot;some name&quot;, email: &quot;some email&quot;) {:ok, %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 652, name: &quot;some name&quot;, age: 1241, email: &quot;some email&quot;, inserted_at: ~U[2020-05-31 20:11:21Z], updated_at: ~U[2020-05-31 20:11:42Z] }}Schema with Changeset ValidationsThe previous schema in Basics section was a simple schema where all fields only contain a primitive type. What happen if we now decided to modify the persons schema to add some field value validations in the changeset/2 function as follow:defmodule YourApp.Schema.Person do use Ecto.Schema import Ecto.Changeset schema &quot;persons&quot; do field :name, :string field :age, :integer field :gender, :string field :email, :string timestamps() end @doc false def changeset(person, attrs) do person |&gt; cast(attrs, [...]) |&gt; validate_inclusion(:gender, [&quot;MALE&quot;, &quot;FEMALE&quot;]) # check if :gender is either &quot;MALE&quot; or &quot;FEMALE&quot; |&gt; validate_email_format() # custom function to check if :email has the correct email format end endFictitious will ignore any kind of validation in the changeset. Performing fictionize/1 function to the new persons schema will still give you a fictitious value for :gender and :email:iex&gt; Fictitious.fictionize(YourApp.Schema.Person) {:ok, %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 1243, name: &quot;2cBfxcqnB0B5iqhYvK83RamaDa8KM0PvPpT1kVao&quot;, age: 632, gender: &quot;7U01hkeHYLLtSVNI3SPaSNSXrACVBsDRwFe13n6l7GzaAakcPkMtODZ2eiioqJHrWXITSLPMu7wJ8&quot; email: &quot;ixV5neQzcap5hq4dXycbt6Mj2fqgPLI3se6qXQbkmHOdoICyaX6&quot;, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }}In case you want the data to have the correct value for :gender and :email you need to specify them manually as previously has shown:iex&gt; Fictitious.fictionize(YourApp.Schema.Person, gender: &quot;MALE&quot;, email: &quot;email@domain.com&quot;) {:ok, %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 564545, name: &quot;xIzommg1lpwgRNBQCcGXLXdxORM7gXGqVIkC3gDL2As1DhxmhdejE0tXR2ImlrXN7j72nDO3Y&quot;, age: 235111, gender: &quot;MALE&quot; email: &quot;email@domain.com&quot;, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }}AssociationsThe true comfort of Fictitious comes when you encounter ecto schemas that have %Ecto.Association.BelongsTo{} relations to other schemas. Given you have the following new countries schema as follow:defmodule YourApp.Schema.Country do use Ecto.Schema import Ecto.Changeset alias YourApp.Schema.Person schema &quot;countries&quot; do field :name, :string has_many :people, Person, foreign_key: :country_id timestamps() end ... endand in a persons schema we add belongs_to relation to countries as follow:defmodule YourApp.Schema.Person do use Ecto.Schema import Ecto.Changeset alias YourApp.Schema.Country schema &quot;persons&quot; do field :name, :string field :age, :integer field :gender, :string field :email, :string belongs_to :nationality, Country, references: :id, foreign_key: :country_id, type: :id # Added belongs_to relation timestamps() end endthen depending on how you set the tables' relation in the DB, it is usually meant that for a person to exist it must belongs to a country hence before any person record could be created, you must at least has one country record. It is possible that a person could exist without a country if no constraint exist in the DB however this is the assumption that Fictitous will always make whenenver a schema has an %Ecto.Association.BelongsTo{} relation. It will always assume that since persons belongs to countries then a country record must exist first.calling fictionize/1 to YourApp.Schema.Country will only makes a fictitious country:iex&gt; Fictitious.fictionize(YourApp.Schema.Country) {:ok, %YourApp.Schema.Country{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;countries&quot;&gt;, id: 67, name: &quot;B8LemwxB8ULP4NLUaFnKfwWkMmBYy8BTytkSN2PiL1UTO47yRM&quot;, people: #Ecto.Association.NotLoaded&lt;association :people is not loaded&gt;, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }}however calling fictionize/1 to YourApp.Schema.Person will creates a person by creating the country first:iex&gt; {:ok, person} = Fictitious.fictionize(YourApp.Schema.Person) {:ok, %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 725, name: &quot;bElHKj9zVwnkLRpO4Y23yon9n80gm1yeAEL4PgtgkxBc0p2Y7C&quot;, age: 364, gender: &quot;dF1O5Eq4ombjzah&quot;, email: &quot;hpOXdOriGA9xaMhnwese40PqqL2Ine&quot;, nationality: #Ecto.Association.NotLoaded&lt;association :nationality is not loaded&gt;, nationality_id: 401, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }} iex&gt; YourApp.Repo.preload(person, :nationality) %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 725, name: &quot;bElHKj9zVwnkLRpO4Y23yon9n80gm1yeAEL4PgtgkxBc0p2Y7C&quot;, age: 364, gender: &quot;dF1O5Eq4ombjzah&quot;, email: &quot;hpOXdOriGA9xaMhnwese40PqqL2Ine&quot;, nationality: %YourApp.Schema.Country{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;countries&quot;&gt;, id: 401, name: &quot;lcb1e86TY6RSccL6vPGjXOv43gnp1t&quot;, people: #Ecto.Association.NotLoaded&lt;association :people is not loaded&gt; inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }, nationality_id: 401, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }Having the belongs_to associations to be created automatically removes the trouble of having to prepare other entities before we could create the wanted entity. This is usually happens a lot of time during preparing unit test data hence this is one problem that Fictitious could solve and save us a lot of time. Fictitious ensures that you get the targeted or wanted entity to be created.In case you want the created fictitious person to belongs to the previously created fictitious country then there are two ways you could do that. First is by manually changing the :country_id as follows:iex&gt; {:ok, country} = Fictitious.fictionize(YourApp.Schema.Country, name: &quot;Indonesia&quot;) {:ok, %YourApp.Schema.Country{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;countries&quot;&gt;, id: 666409, name: &quot;Indonesia&quot;, people: #Ecto.Association.NotLoaded&lt;association :people is not loaded&gt;, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }} iex&gt; {:ok, person} = Fictitious.fictionize(YourApp.Schema.Person, country_id: country.id) {:ok, %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 5230, name: &quot;FZcb5Q4zLOO4aMrdi1RblsEPpushgAn9zoPtfMbJWlsNe&quot;, age: 5768, gender: &quot;FBTG2Ls4Fi9nD6oazpPjBqti5DfdmqyGTaQp5xlxjiH9B&quot;, email: &quot;cgOACnmDFqbO5NxEZ0AUtwtjEfZBMcv3QzAq3esrcJHo7&quot;, nationality: #Ecto.Association.NotLoaded&lt;association :nationality is not loaded&gt;, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }}or second, by passing the whole %YourApp.Schema.Country{} struct as follows:iex&gt; {:ok, country} = Fictitious.fictionize(YourApp.Schema.Country, name: &quot;Indonesia&quot;) {:ok, %YourApp.Schema.Country{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;countries&quot;&gt;, id: 7914, name: &quot;Indonesia&quot;, people: #Ecto.Association.NotLoaded&lt;association :people is not loaded&gt;, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }} iex&gt; {:ok, person} = Fictitious.fictionize(YourApp.Schema.Person, nationality: country) {:ok, %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 451, name: &quot;ZFvtidsGOPh6OymYJk529bL2QT9KMZic2A0ietddl2RWy&quot;, age: 150940, gender: &quot;rHZYpbDgJQokDX2vSpSfWUmELrTb9f&quot;, email: &quot;xmcuHrJvotjAQz6itQnZtoMp&quot;, nationality: #Ecto.Association.NotLoaded&lt;association :nationality is not loaded&gt;, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }}Self-referencing SchemaGiven we edit the persons schema to self-reference to itself as follows:defmodule YourApp.Schema.Person do use Ecto.Schema import Ecto.Changeset alias YourApp.Schema.Person alias YourApp.Schema.Country schema &quot;persons&quot; do field :name, :string field :age, :integer field :gender, :string field :email, :string belongs_to :parent, Person, references: :id, foreign_key: :parent_id, type: :id # Self-reference to itself belongs_to :nationality, Country, references: :id, foreign_key: :country_id, type: :id timestamps() end endthen calling fictionize/1 to YourApp.Schema.Person will not create the self-reference schema:iex&gt; {:ok, person} = Fictitious.fictionize(YourApp.Schema.Person) {:ok, %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 725, name: &quot;bElHKj9zVwnkLRpO4Y23yon9n80gm1yeAEL4PgtgkxBc0p2Y7C&quot;, age: 364, gender: &quot;dF1O5Eq4ombjzah&quot;, email: &quot;hpOXdOriGA9xaMhnwese40PqqL2Ine&quot;, parent: #Ecto.Association.NotLoaded&lt;association :parent is not loaded&gt;, parent_id: nil, nationality: #Ecto.Association.NotLoaded&lt;association :nationality is not loaded&gt;, nationality_id: 131421, inserted_at: ~U[2020-04-31 06:19:27Z], updated_at: ~U[2020-04-31 06:19:27Z] }}This is done so that Fictitious does not trapped in an infinite loop when creating a self-referencing schema.Giving Null ValueBy default Fictitious will always generate a fictitious values to all fields in an ecto schema. If you want certain fields to be nil or null you could give :null as the value as follows:iex&gt; {:ok, person} = Fictitious.fictionize(YourApp.Schema.Person, name: :null) {:ok, %YourApp.Schema.Person{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;persons&quot;&gt;, id: 725, name: nil, age: 54245, gender: &quot;aF1F5Eq4ambquih&quot;, email: &quot;hpOXdOriGA9xaMhnwese40PqqL2Ine&quot;, parent: #Ecto.Association.NotLoaded&lt;association :parent is not loaded&gt;, parent_id: nil, nationality: #Ecto.Association.NotLoaded&lt;association :nationality is not loaded&gt;, nationality_id: 531, inserted_at: ~U[2020-07-22 11:38:27Z], updated_at: ~U[2020-07-22 11:38:27Z] }}Multiple ReposGiven you configured the Fictitious repo as follow:config :fictitious, :repo, default: YourApp.Repo, second_repo: YourApp.SecondRepothen to use the second repo you could use fictionize/2 or fictionize/3 as follows:iex&gt; Fictitious.fictionize(YourApp.Schema.Continent, :second_repo) iex&gt; Fictitious.fictionize(YourApp.Schema.Continent, :second_repo, name: &quot;overwrite name&quot;)","ref":"Fictitious.html","title":"Fictitious","type":"module"},{"doc":"","ref":"Fictitious.html#fictionize/1","title":"Fictitious.fictionize/1","type":"function"},{"doc":"","ref":"Fictitious.html#fictionize/2","title":"Fictitious.fictionize/2","type":"function"},{"doc":"","ref":"Fictitious.html#fictionize/3","title":"Fictitious.fictionize/3","type":"function"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fix unknow association from ecto causes error.","ref":"changelog.html#0-2-2","title":"Changelog - 0.2.2","type":"extras"},{"doc":"Support belongs to association where the child entity does not reference to parent entity through primary key.","ref":"changelog.html#0-2-1","title":"Changelog - 0.2.1","type":"extras"},{"doc":"Support self-referencing schema. Fix bug where self-referencing schema causes fictitious to end up in infinite loop.Enable fictitious value to be override with null value by providing :null as the value.Remove ecto_sql and postgrex as dependencies.","ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras"},{"doc":"First release of fictitious","ref":"changelog.html#0-1-1","title":"Changelog - 0.1.1","type":"extras"}]